% TMS 

Cr = 50e-3; % mM fixed ion concentration in the membrane   
C2overC1 = 5;
C1 = logspace(-5,2,30);% low concentration 
C2 = C2overC1*C1;% high concentration  

D1 = 1.957e-9; % K
%D1 = 1.097e-9; % Li diffusivity
%D1 = 0.792e-9; %Ca diffusivity
%D1= 0.706e-9% Mg diffusivity
D2 = 2.032e-9; % Cl
%D2 = 1.065e-9; % SO4

%D1= 1;
%D2=2;
%alpha = 0.6791; % "permselectivity" actually, effectiveness factor for leaks - intrinsic to membrane, independent of salt
alpha=1
u = (D1-D2)/(D1+D2);

R = 8.314; % 8.314 J/mol K
F = 1.609e-19*6.022e23; % C/mol
T = 298; % K

CorrectFactor = (sqrt(4.*C1.^2+Cr.^2)+Cr)./(sqrt(4.*C2.^2+Cr.^2)+Cr);

deltaPhi_donnan = -R*T/F*log(C2./C1.*CorrectFactor);
deltaPhi_diff = -R*T/F*u.*log((sqrt(4.*C2.^2+Cr.^2)+u.*Cr)./(sqrt(4.*C1.^2+Cr.^2)+u.*Cr));
deltaPhi = alpha*(deltaPhi_donnan)+deltaPhi_diff;
%deltaPhi'
%semilogx(C1,-deltaPhi,'--',C1,-deltaPhi_diff,'o--',C1,-deltaPhi_donnan,'^--')
% deltaPhi is the potential generated. 
semilogx(C1,-deltaPhi,'-')
C1'
deltaPhi'
