function TMS_superDona_fit()

C1data = [xlsread('MFile1','KCl','A2:A23')' xlsread('MFile1','KCl','A2:A23')' xlsread('MFile1','KCl','A2:A23')']*1000; %mM
C2overC1 = [5*ones(size(C1data))];
%1.029e-9*ones(1,length(C1data)); % in case you switch salts
%D2 = 2.032e-9*ones(1,length(C1data));

% D1 = 1.957e-9*ones(1,length(C1data));
D1 = [1.957e-9*ones(1,22) 1.957e-9*ones(1,22) 1.957e-9*ones(1,22)];
% in case you switch salts
% D2 = 1.065e-9*ones(1,length(C1data));
D2 = [2.032e-9*ones(1,22) 2.032e-9*ones(1,22) 2.032e-9*ones(1,22)];
% C1data = [C1data_KCl C1data_NaCl C1data_KCl];
% C2overC1 = [C2overC1_KCl C2overC1_NaCl C2overC1_LiCl];
% D1 = [D1_KCl D1_NaCl D1_LiCl];
% D2 = [D2_KCl D2_NaCl D2_LiCl];
% phiData = [phiData_KCl phiData_NaCl phiData_LiCl];
phiData=-[xlsread('MFile1','KCl','E2:E23')' xlsread('MFile1','KCl','F2:F23')' xlsread('MFile1','KCl','G2:G23')'];
Cr_guess = 10; % mM
alpha_guess =  0.6599;% effectiveness factor
D1overD2_guess = 1;

options = optimset('Display','iter');

[betas,resnorm,res,exitflag,output,lambda,jac] = lsqcurvefit(@TMS_calculator,[Cr_guess alpha_guess D1overD2_guess],C1data,phiData,[0 0 0],[100 1 100],options,C2overC1,D1,D2);

[std,varresid,r2,cor,vcv,varinf]=regdata(betas,phiData+res,phiData,jac);

-phiData';

phiCalc = -(phiData+res)';


figure (3)
semilogx(C1data,-phiData,'o',C1data,-(phiData+res),'--')

% TMS 
Cr = betas(1); % mM
alpha = betas(2);
D1overD2 = betas(3);
%C2overC1 = 5;
%C1 = logspace(-1,2,50);
C1=C1data;
C2=C2overC1.*C1data;
%D1 = 1.33e-9; % Na
%D2 = 2.03e-9; % Cl
%alpha = 0.65; % "permselectivity" actually, effectiveness factor for leaks - intrinsic to membrane, independent of salt
u = (1-D1overD2)./(1+D1overD2);
%u = -0.15;
R = 8.314; % 8.314 J/mol K
F = 1.609e-19*6.022e23; % C/mol
T = 298; % K

CorrectFactor = (sqrt(4.*C1.^2+Cr.^2)+Cr)./(sqrt(4.*C2.^2+Cr.^2)+Cr);

deltaPhi_donnan = -R*T/F*log(C2./C1data.*CorrectFactor)';
deltaPhi_diff = -R.*T./F.*u.*log((sqrt(4.*C2.^2+Cr.^2)+u.*Cr)./(sqrt(4.*C1.^2+Cr.^2)+u.*Cr));
deltaPhi_diff = deltaPhi_diff';
deltaPhi_calc = alpha.*(deltaPhi_donnan)+deltaPhi_diff;
deltaPhi_calc = deltaPhi_calc;

deltaPhi_donnan_Dona = deltaPhi_donnan(1:22)
deltaPhi_diff_Dona = deltaPhi_diff(1:22)
deltaPhi_calc_Dona = deltaPhi_calc(1:22)



function F = TMS_calculator(betas,C1,C2overC1,D1,D2)

% TMS 
Cr = betas(1); % mM
alpha = betas(2);
D1overD2 = betas(3);
%C2overC1 = 5;
%C1 = logspace(-1,2,50);
C2=C2overC1.*C1;
%D1 = 1.33e-9; % Na
%D2 = 2.03e-9; % Cl
%alpha = 0.65; % "permselectivity" actually, effectiveness factor for leaks - intrinsic to membrane, independent of salt
u = (1-D1overD2)./(1+D1overD2);
%u = -0.15;
R = 8.314; % 8.314 J/mol K
F = 1.609e-19*6.022e23; % C/mol
T = 298; % K

CorrectFactor = (sqrt(4.*C1.^2+Cr.^2)+Cr)./(sqrt(4.*C2.^2+Cr.^2)+Cr);

deltaPhi_donnan = -R*T/F.*log(C2./C1.*CorrectFactor);
deltaPhi_diff = -R.*T./F.*u.*log((sqrt(4.*C2.^2+Cr.^2)+u.*Cr)./(sqrt(4.*C1.^2+Cr.^2)+u.*Cr));
deltaPhi1 = alpha.*(deltaPhi_donnan)+deltaPhi_diff;
F = deltaPhi1;
figure(4)
semilogx(C1,-deltaPhi1,'s',C1,-alpha*deltaPhi_diff,'*',C1,-alpha*deltaPhi_donnan,'^')