function TMS_superDona_fitdivalent()
close all;
clear all;
clc;
C1data = [xlsread('MFile1','K2SO4','A2:A17')' xlsread('MFile1','K2SO4','A2:A17')' xlsread('MFile1','K2SO4','A2:A17')']*1000; %mM
C2overC1 = [5*ones(size(C1data))];
%C2overC1 = 5.*C1data;%cf
D1 = [1.957e-9*ones(1,16) 1.957e-9*ones(1,16) 1.957e-9*ones(1,16)];
D2 = [1.065e-9*ones(1,16) 1.065e-9*ones(1,16) 1.065e-9*ones(1,16)];
phiData=-[xlsread('MFile1','K2SO4','E2:E17')' xlsread('MFile1','K2SO4','F2:F17')' xlsread('MFile1','K2SO4','H2:H17')'];
Cr_guess = 80; % mM
alpha_guess =  0.8;% effectiveness factor
D1overD2_guess =0.43;
options = optimset('Display','iter');

[betas,resnorm,res,exitflag,output,lambda,jac] = lsqcurvefit(@TMS_calculator,[Cr_guess alpha_guess D1overD2_guess],C1data,phiData,[0 0 0],[200 1 1],options,C2overC1);

[std,varresid,r2,cor,vcv,varinf]=regdata(betas,phiData+res,phiData,jac);

figure (3)
semilogx(C1data,-phiData,'o',C1data,-(phiData+res),'*')
function F = TMS_calculator(betas,C1,C2overC1,D1,D2)

% TMS 
Cr = betas(1); % mM
alpha = betas(2);
D1overD2 = betas(3);
%alpha = 0.65; % "permselectivity" actually, effectiveness factor for leaks - intrinsic to membrane, independent of salt
R = 8.314; % 8.314 J/mol K
F1 = 1.609e-19*6.022e23; % C/mol
T = 298; % K
Z2=2;
Z1=1;
C2=C2overC1.*C1;
t1=Z1./(Z2.*D1overD2+Z1);
ubar = (1-D1overD2)./(Z2*D1overD2+Z1);
tr=C1./C2;
v1=2; %stoichiometric coefficient of the electrolyte
ep=(Cr./C1)./Z1./v1;
ef= (Cr./C2)./Z1./v1;
lambdap=108+12*sqrt(3).*sqrt(27+4.*(ep).^3);
gammap= (((lambdap.^(1/3))/6)-((2.*ep)./(lambdap).^(1/3))).^(-1);
kp=(gammap).^(-2);
lambdaf=108+12*sqrt(3).*sqrt(27+4.*(ef).^3);
gammaf= (((lambdaf.^(1/3))/6)-((2.*ef)./(lambdaf).^(1/3))).^(-1);
kf=(gammaf).^(-2);
Donnan = (1/Z2)*log(kp./kf);
%ubar=((D1-D2)/((Z2*D2)+(Z1*D1)));
Diffusion =ubar*log((tr.*kp+t1.*ef)./(kf+t1.*ef));
deltaPhi1 = ((R*T)/F1).*(alpha*Donnan+Diffusion);
F = deltaPhi1;
alphanew=(alpha*R*T)/F1;
figure(4)
semilogx(C1,-deltaPhi1,'s', C1,-alphanew*Donnan,'*',C1,-alphanew*Diffusion,'^')
deltaPhi1';
